CREATE OR REPLACE FUNCTION IncrementTimeQuotaConsumption 
	( INTEGER, VARCHAR(32), INTEGER, BIGINT, BIGINT ) RETURNS INTEGER AS '
DECLARE
	period  ALIAS FOR $1 ;
	digest  ALIAS FOR $2 ;
    rule    ALIAS FOR $3 ;
	inc     ALIAS FOR $4 ;
    next_check_time   ALIAS FOR $5;
	
	current_timeframe INTEGER ;
BEGIN
	SELECT INTO current_timeframe CurrentTimeframe ( period ) ;

	UPDATE tb_TimeQuotaConsumption 
		SET "Consumption" = "Consumption" + inc, 
			"LastUpdateTime" = ''now'',
            "Rule" = rule,
            "NextCheckTime" = next_check_time
		WHERE "Digest" = digest 
		AND "Timeframe" = current_timeframe ;
	IF NOT FOUND THEN
		UPDATE tb_TimeQuotaConsumption 
			SET "Consumption" = inc, "Timeframe" = current_timeframe, 
				"LastUpdateTime" = current_timestamp,
				"ExtraQuota"=0,
                "Rule" = rule,
                "NextCheckTime" = next_check_time
			WHERE "Digest" = digest ;
	END IF ;
	RETURN 0 ;
END ;
' LANGUAGE 'plpgsql' ;

